import scrapy
from scrapy.linkextractors import LinkExtractor
from scrapy.spiders import CrawlSpider, Rule


class Qu3Spider(CrawlSpider):
    name = 'qu3'
    allowed_domains = ['qu.la']
    start_urls = ['https://www.qu.la/book/4703/']

    rules = (
        Rule(LinkExtractor(restrict_xpaths=r'/html/body/div[3]/div[2]/div/div[2]/ul/ul/li[1]/a'), callback='parse_item', follow=True),
        Rule(LinkExtractor(restrict_xpaths=r'//div[@class="section-opt"]/a[3]'), callback='parse_item', follow=True),
    )

    def parse_item(self, response):
        title = response.xpath('//h1/text()').extract_first()
        content = response.xpath('string(//div[@class="content"])').extract_first().strip().replace('　　　　    ', '\n')
        yield {
            'title': title,
            'content': content
        }
